<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.process.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class process {

//---- Process Filter

    function process_filter() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$search = ($_GET[search]) ? $_GET[search] : $_POST[search] ;
	$err = ($_GET[err]) ? $_GET[err] : $_POST[err] ;

	$tranobj = CreateObject("$app.$tran") ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-api'));
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','select','select_section');
	$t->set_block('report','detail','detail_section');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	
	$msg1 = lang('To search for all items, leave fields blank.') ;
	$msg2 = lang('Maximum length of search string is 15 characters.') ;
	$t->set_var('std_message',"$msg1  $msg2");

	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;

	if ($err) {
		$t->set_var('lang_search_message',"<b>$err</b>") ;
		foreach ($ckapi[filter] as $key => $row) {
			$varname = $row[varname] ;
			$ckapi[filter][$key][defval] = ($_GET[$varname]) ? $_GET[$varname] : $_POST[$varname] ;
			}
		}
	$detail = $select = False ;
	foreach ($ckapi[filter] as $key => $row)	{
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->set_var('criteria',$row[criteria]);
		$t->set_var('varname',$row[varname]);
		$t->set_var('note',$row[note]);
		switch ($row[type])	:
			case "input" :
				$t->set_var('defval',$row[defval]);
				$t->set_var('checkbox',"");
				$t->set_var('checked',"");
				$t->parse('detail_section','detail', True);
				$detail = True ;
				break ;
			case "checkbox" :
				$t->set_var('defval','yes');
				$t->set_var('checkbox',"type='checkbox'");
				$checked = ($row[defval]=='yes') ? "checked" : "" ;
				$t->set_var('checked',$checked);
				$t->parse('detail_section','detail', True);
				$detail = True ;
				break ;
			case "select" :
				$defval = $row[defval] ;
				$sl = str_replace("'$defval'","'$defval' selected",$row[selectlist]) ;
				$t->set_var('selectlist',$sl);
				$t->parse('select_section','select', True);
				$select = True ;
				break ;
			endswitch ;
		}
	if (!$detail)	$t->set_var('detail_section','');
	if (!$select)	$t->set_var('select_section','');
	$t->parse('out','report',True);

	$getstr = $ckapi[filter][getstr] ;
	$act_script = ($search_action) ? $search_action : "${tran}filter_validate.php" ;
	$t->set_var('search_action',$phpgw->link("/$app/$act_script",$getstr)) ;
	$act_script = ($doneexit) ? $doneexit : "${tran}add.php" ;
	$t->set_var('add_action',$phpgw->link("/$app/$act_script")) ;
	$t->pparse('out','report',True);
	}
	
//---- Process Filter Validate

    function process_filter_validate() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	foreach ($ckapi[sql_filter] as $key => $val)	if (!is_numeric($key))	$$key = ($_GET[$key]) ? $_GET[$key] : $_POST[$key] ;
	
	$err="" ;  $error=lang("Error") ;  $markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
	foreach ($ckapi[sql_filter] as $key => $val) {
		if ($$key=="")					continue ;
		if ($ckapi[sql_filter][$key][type]=='string') {
			if (strlen($$key)>15)			$err="[".$$key."]".lang("Search string too long") ;
			if (substr_count($$key,$markpri)>0)	
				$err="[".$$key."]".lang("Search string contains reserved pattern")." - $markpri";
			if (substr_count($$key,$marksec)>0)	
				$err="[".$$key."]".lang("Search string contains reserved pattern")." - $marksec";
			if (substr_count($$key," ")>0)	
				$err="[".$$key."]".lang("Search string should not contain space(s)");
			}
		if ($ckapi[sql_filter][$key][type]=='date') {
			$temp = input2date($$key) ;
			if ($temp=="")				$err="[".$$key."]".lang("Invalid date"); else $$key = $temp ;
			}
		}
	if ($err)						$err = "$error:  $err" ;

	if (!$err) {
		foreach ($ckapi[sql_filter] as $key => $val) {
			if ($val[char]=="1") {
				if ($$key<>"ALL")				$filter.=$markpri.$val[char].$val[str1].$marksec.$$key;
				continue ;
				}
			if ($val[char]=="7") {
				if ($$key=="yes")				$filter.= $markpri.$val[char] ;
				continue ;
				}
			if ($val[char]=="8") {
				if ($$key=="yes")				$filter.= $markpri.$val[char].$val[str1] ;
				continue ;
				}
			if (is_numeric($key) or $$key) {
										$filter.= $markpri.$val[char].$val[str1] ;
				if (substr_count("2,3,4,5,6",$val[char])>0)	$filter.= $marksec.$$key ;
				}
			}
		$filter = urlencode($filter) ;
		Header('Location: '.$phpgw->link("/$app/${tran}list.php","filter=$filter"));
		exit();
		}
	  else	{
		foreach ($ckapi[sql_filter] as $key => $val)	if (!is_numeric($key))	$getstr.= "$key=".$$key."&";
		$getstr.= "err=$err" ;
		Header('Location: '.$phpgw->link("/$app/${tran}filter.php",$getstr));
		exit();
		}
	}

//---- Process Read

    function process_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$phpgw->db->query("SELECT * from $table WHERE id='$id'");
	$phpgw->db->next_record();
	if (!is_array($uniqueflds) or $op<>'edit')    return $phpgw->db->Record;
	  else  {
		$dt = $phpgw->db->Record ;
	  	foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
		return $dt ;
		}
	}

//---- Process List

    function process_list() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$filter = urldecode(stripslashes($filter)) ;
	$where = $this->decode_where($filter) ;
	$filter = urlencode($filter) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report'=>"${tran}list.tpl", 'detail'=>"${tran}list.tpl"));
	$t->set_block('detail','detail_row','detail_section');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;
	$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));

	$script = "/$app/${tran}list.php" ;
	foreach ($ckapi[columns] as $key => $value)	{$field1=$key; break;}
	foreach ($ckapi[columns] as $key => $value)
		$t->set_var("sort_${key}",$nm->show_sort_order($sort,$key,$order,$script,$value));

	if (!$order)	{if ($sortkey<>"")	$order=$sortkey;	else $order=$field1;}
	if (!$sort)	$sort = "ASC" ;
	$phpgw->db->query("SELECT * from $table WHERE $where order by $order $sort");

	if ($phpgw->db->num_rows()==0) {
		foreach ($ckapi[columns] as $key => $value)	$t->set_var($key,"") ;
		$t->set_var("$field1",lang("No Matching Item Found")) ;
		$return = $phpgw->link("/$app/${tran}filter.php") ;
		$t->set_var(array(	'view'	=> $return,
					'edit'	=> $return,
					'copy'	=> $return,
					'delete'=> $return,
					'log'	=> $return  ));
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail_row',True);
		}
	while ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$getstr = "id=$id&filter=$filter" ;
		$loggetstr = "return=/$app/${tran}list.php&$getstr" ;
		foreach ($ckapi[columns] as $key => $value)	$t->set_var($key,$phpgw->db->f($key)) ;
		$t->set_var(array(	'view'	=> $phpgw->link("/$app/${tran}view.php",$getstr),
					'edit'	=> $phpgw->link("/$app/${tran}edit.php",$getstr),
					'copy'	=> $phpgw->link("/$app/${tran}copy.php",$getstr),
					'delete'=> $phpgw->link("/$app/${tran}delete.php",$getstr),
					'log'	=> $phpgw->link('/ck-admin/loglist.php',$loggetstr) 	));
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail_row',true);
		}

	$t->set_var('add_action',$phpgw->link("/$app/${tran}add.php",$getstr));
	$t->set_var('lang_edit',lang('Edit'));
	$t->set_var('lang_view',lang('View'));
	$t->set_var('lang_copy',lang('Copy/Modify'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_log',lang('Log'));
	$t->pparse('out','detail','report');
	}

//---- Process View

    function process_view() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[phrases] as $key => $value)	$$key = $value ;
//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=stripslashes($filter);

	$tranobj = CreateObject("$app.$tran") ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file(array('view'=>"${tran}screen.tpl", 'report'=>"${tran}screen.tpl"));
	$t->set_block('report','detail','detail_section');
	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','');

	$ckapi[params_post][id] = $id ;
	$ckapi[params_post][posted] = True ;
	$ckapi[params_post][dt] = $this->process_read() ;
	$ckapi[objects][template] = &$t ;
	$func = $tran."_write" ;	$tranobj->$func() ;

	$getstr = "filter=$filter" ;
	$t->set_var('action',$phpgw->link("/$app/${tran}list.php",$getstr)) ;
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('done_action',$phpgw->link("/$app/${tran}list.php",$getstr)) ;
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report', True );
	}

//---- Process Add

    function process_add() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[phrases] as $key => $value)	$$key = $value ;
//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$filter=stripslashes($filter);

	$tranobj = CreateObject("$app.$tran") ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file(array('view'=>"${tran}screen.tpl", 'report'=>"${tran}screen.tpl"));
	$t->set_block('report','detail','detail_section');
	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;

	$ckapi[params_post][dt] = $_POST ;
	$ckapi[objects][template] = &$t ;
	$func = $tran."_write" ;	$tranobj->$func() ;

	if (isset($post)) {
		$func = $tran."_validate" ;
		$err = $tranobj->$func() ;
		$t->set_var('message',$err) ;
		if ($err=='') {
			$this->process_post();
			$posted = True ;
			}
		}

	$getstr="filter=$filter";
	$return = ($filter=="") ? "${tran}filter.php" : "${tran}list.php" ;
	if ($posted) {
		$t->set_var('action',$phpgw->link("/$app/$return",$getstr));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('readonly','readonly') ;
		$t->set_var('disabled','disabled');
		}
	    else {
		$t->set_var('action',$phpgw->link("/$app/${tran}add.php",$getstr)) ;
		$t->set_var('lang_post',$lang_post);
		$t->set_var('readonly','') ;
		$t->set_var('disabled','');
		}
	$t->set_var('done_action',$phpgw->link("/$app/$return",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);
	}

//---- Process Copy

    function process_copy() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[phrases] as $key => $value)	$$key = $value ;
//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$filter=stripslashes($filter);

	$tranobj = CreateObject("$app.$tran") ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file(array('view'=>"${tran}screen.tpl", 'report'=>"${tran}screen.tpl"));
	$t->set_block('report','detail','detail_section');
	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;

	if (!isset($post)) {
		$ckapi[params_post][id] = $id ;
		$_POST=$this->process_read();
		$_POST['id']="";
		}
	$ckapi[params_post][dt] = $_POST ;
	$ckapi[objects][template] = &$t ;
	$func = $tran."_write" ;	$tranobj->$func() ;

	if (isset($post)) {
		$func = $tran."_validate" ;
		$err = $tranobj->$func() ;
		$t->set_var('message',$err) ;
		if ($err=='') {
			$this->process_post();
			$posted = True ;
			}
		}

	$getstr = "filter=$filter";
	if ($posted) {
		$t->set_var('action',$phpgw->link("/$app/${tran}list.php",$getstr));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('readonly','readonly') ;
		$t->set_var('disabled','disabled');
		}
	    else {
		$t->set_var('action',$phpgw->link("/$app/${tran}copy.php",$getstr)) ;
		$t->set_var('lang_post',$lang_post);
		$t->set_var('readonly','') ;
		$t->set_var('disabled','');
		}
	$t->set_var('done_action',$phpgw->link("/$app/${tran}list.php",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);
	}

//---- Process Edit

    function process_edit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[phrases] as $key => $value)	$$key = $value ;
//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$post = ($_GET["post"]) ? $_GET["post"] : $_POST["post"] ;
	$filter=stripslashes($filter);

	$tranobj = CreateObject("$app.$tran") ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file(array('view'=>"${tran}screen.tpl", 'report'=>"${tran}screen.tpl"));
	$t->set_block('report','detail','detail_section');
	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;

	if (!isset($post)) {
		$ckapi[params_post][id] = $id ;
		$_POST=$this->process_read();
		}
	$ckapi[params_post][dt] = $_POST ;
	$ckapi[objects][template] = &$t ;
	$func = $tran."_write" ;	$tranobj->$func() ;

	if (isset($post)) {
		$func = $tran."_validate" ;
		$err = $tranobj->$func() ;
		$t->set_var('message',$err) ;
		if ($err=='') {
			$err=$this->process_post();
			if ($err<>"")	$t->set_var('message',$err) ;
				else	$posted = True ;
			}
		}

	$getstr="filter=$filter";
	if ($posted) {
		$t->set_var('action',$phpgw->link("/$app/${tran}list.php",$getstr));
		$t->set_var('lang_post',lang('Done'));
		$t->set_var('readonly','readonly') ;
		$t->set_var('disabled','disabled');
		}
	    else {
		$t->set_var('action',$phpgw->link("/$app/${tran}edit.php",$getstr)) ;
		$t->set_var('lang_post',$lang_post);
		$t->set_var('readonly','') ;
		$t->set_var('disabled','');
		}
	$t->set_var('done_action',$phpgw->link("/$app/${tran}list.php",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);
	}

    function process_delete() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[phrases] as $key => $value)	$$key = $value ;
//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$control = ($_GET["control"]) ? $_GET["control"] : $_POST["control"] ;
	$yes = ($_GET["yes"]) ? $_GET["yes"] : $_POST["yes"] ;
	$filter=stripslashes($filter);

	$tranobj = CreateObject("$app.$tran") ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('question','confirm.tpl');
	$t->set_file('report',"${tran}screen.tpl") ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_confirm',lang('Are you sure you want to delete ?'));
	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;
	$t->set_var('readonly',"readonly");
	$t->set_var('disabled',"disabled");

	$ckapi[params_post][id] = $id ;
	$ckapi[params_post][posted] = True ;
	$_POST=$this->process_read();
	$ckapi[params_post][dt] = $_POST ;
	$ckapi[objects][template] = &$t ;
	$func = $tran."_write" ;	$tranobj->$func() ;

	if (!isset($yes)) 	$control = $_POST['control'] ;
	  else	{
		$_POST[id] = $id ;
		$_POST['control'] = $control ;
		$err = $this->delete_validate() ;
		if ($err=="")	if (method_exists($tranobj,"delete_validate"))	$err=$tranobj->delete_validate();
		if ($err<>'')	{unset($yes); $t->set_var('lang_title',"$lang_title => $err");}
		}
	$getstr="filter=$filter&control=$control";
	if (!isset($yes)) {
		$t->set_var('lang_yes',lang('Yes'));
		$t->set_var('lang_no',lang('No'));
		$getstr .= "&id=$id" ;
		$t->set_var('yes_action', $phpgw->link("/$app/${tran}delete.php",$getstr));
		$t->set_var('no_action',$phpgw->link("/$app/${tran}list.php",$getstr)) ;
		$t->pparse('out','question',True);
		}
	   else {
		$err=$this->process_post($params,$phrases,$_POST, $t);
		$t->set_var('lang_yes',lang('done'));
		$t->set_var('lang_no',lang('done'));
		$t->set_var('yes_action',$phpgw->link("/$app/${tran}list.php",$getstr)) ;
		$t->set_var('no_action',$phpgw->link("/$app/${tran}list.php",$getstr)) ;
		$t->pparse('out','question',True);
		if ($err<>'')	$t->set_var('lang_title',"$lang_title => $err");
		}

	$t->set_var('action',$phpgw->link("/$app/${tran}list.php",$getstr));
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('done_action',$phpgw->link("/$app/${tran}list.php",$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);
	}

//---- Process Post (posting data to db table)

    function process_post() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	foreach ($ckapi[phrases] as $key => $value)	$$key = $value ;

	$db_type = $ckapi[hostsys][dbtype] ;
	if ($op=="copy" or $op=="add")	$op=$ckapi[params_post][op]="new" ;
	$id = ($dt[id]=="") ? 0 : $dt[id] ;
	$ip = ($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'] ;
	$user = $ckapi[hostsys][username];
	$now = mktime() ;
	$iptime = "$ip=$now=$script=$id" ;

	if ($op<>"new") {
		$err=""; $error=lang('Error') ;
		$lang_deleted = lang("was deleted while your request was processed") ;
		$lang_modified= lang("was modified while your request was processed") ;
		$lang_restart = lang("Please exit current screen and restart action if necessary");
		$phpgw->db->query("SELECT control FROM $table WHERE id = '$id'");
		$phpgw->db->next_record();
		if ($phpgw->db->num_rows()==0)
			$err = "<b>$error: $tran [id#$id]: $lang_deleted.  $lang_restart.</b>";
		if ($dt[control] < $phpgw->db->f('control'))
			$err = "<b>$error: $tran [id#$id]: $lang_modified.  $lang_restart.</b>" ;
		if ($err)	return $err ;
		$control = $dt[control] + 1 ;
		}

	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);
	$sql = "INSERT INTO ${pre}log (trans_id,app,script,ip,userid,op,timestamp,iptime) " ;
	$sql.= "VALUES ('$id','$app','$script','$ip','$user','$op','$now','$iptime')" ;
	$phpgw->db->query($sql);
	$phpgw->db->query("SELECT id from ${pre}log WHERE iptime='$iptime'");
	$phpgw->db->next_record();
	$logid = $phpgw->db->f('id');

	switch ($op) :
		case "new" :
			$id = $logid ;
			$sql = "SELECT a.attname, format_type(a.atttypid,a.atttypmod) " ;
			$sql.= "FROM pg_class c,pg_attribute a ";
			$sql.= "WHERE c.relname='$table' and a.attnum>0 and a.attrelid=c.oid" ;
			if ($db_type=="mysql")		$sql = "describe $table" ;
			$phpgw->db->query($sql);
			While ($phpgw->db->next_record()) {
				$fldname = $phpgw->db->Record[0] ;
				$val = $dt["$fldname"] ;
				if ($fldname<>'control' and $fldname<>'id') {
					$val = $dt["$fldname"] ;
					$fields.="$fldname," ;
					$values.="'$val'," ;
					}
				}
			$sql = "INSERT INTO $table ($fields id) VALUES ($values '$id')" ;
			$phpgw->db->query($sql);
			$ckapi[params_post][id] = $id ;
			$ckapi[params_post][logid] = $logid ;
			$this->update_log_header() ;
			$type = lang("New") ;
			$actioned = lang("added") ;
			break ;
		case "edit" :
			$sql = "SELECT a.attname, format_type(a.atttypid,a.atttypmod) " ;
			$sql.= "FROM pg_class c,pg_attribute a ";
			$sql.= "WHERE c.relname='$table' and a.attnum>0 and a.attrelid=c.oid" ;
			if ($db_type=="mysql")		$sql = "describe $table" ;
			$phpgw->db->query($sql);
			While ($phpgw->db->next_record()) {
				$fldname = $phpgw->db->Record[0] ;
				$val = $dt["$fldname"] ;
				if ($fldname<>'control')	$fields.="$fldname='$val'," ;
				}
			$sql = "UPDATE $table SET $fields control='$control' WHERE id='$id'" ;
			$phpgw->db->query($sql);
			$ckapi[params_post][id] = $id ;
			$ckapi[params_post][logid] = $logid ;
			$this->update_log_header() ;
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			break ;
		case "delete" :
			$ckapi[params_post][id] = $id ;
			$ckapi[params_post][logid] = $logid ;
			$this->update_log_header() ;
			$phpgw->db->query("DELETE from $table where id = $id");
			$type = lang("Old") ;
			$actioned = lang("deleted") ;
			break ;
		endswitch ;

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);
	$t = &$ckapi[objects][template] ;
	$t->set_var('disabled',"disabled") ;
	$t->set_var('readonly',"readonly");
	$t->set_var("message","<b>$type $lang_tran [id#$id] $actioned.  $reminder</b>") ;
	$t->set_var('lang_confirm',"<b>$type $lang_tran [id#$id] $actioned.</b>");
	return $err ;
	}

//---- Update Log Header

    function update_log_header() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$phpgw->db->query("SELECT * FROM $table WHERE id = '$id'");
	$phpgw->db->next_record();
	$headerarr["$table"] = $phpgw->db->Record;
	$header = addslashes(serialize($headerarr));
	$fields = "header='$header'" ;
	if ($op=="new")	$fields="trans_id=id,$fields" ;
	$phpgw->db->query("UPDATE ${pre}log SET $fields WHERE id='$logid'");
	}

//---- Standard Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$err=""; $error=lang('Error') ;
	$errmsg1 = lang("This item is in use within an existing") ;
	$journal = lang("journal") ;
	$id = $dt[id] ;
	$phpgw->db->query("SELECT attrib1tbl,attrib2tbl,attrib3tbl from ${pre}defaults");
	$phpgw->db->next_record();
	$a1tbl = $phpgw->db->f('attrib1tbl') ;
	$a2tbl = $phpgw->db->f('attrib2tbl') ;
	$a3tbl = $phpgw->db->f('attrib3tbl') ;
	if ($a1tbl == $table) {
		$phpgw->db->query("SELECT * from ${pre}acc_trans WHERE attrib1='$id'");
		if ($phpgw->db->num_rows()>0) {
			$phpgw->db->next_record();
			$err = "$errmsg1 $journal id#".$phpgw->db->f('trans_id') ;
			}
		}
	if ($a2tbl == $table) {
		$phpgw->db->query("SELECT * from ${pre}acc_trans WHERE attrib2='$id'");
		if ($phpgw->db->num_rows()>0) {
			$phpgw->db->next_record();
			$err = "$errmsg1 $journal id#".$phpgw->db->f('trans_id') ;
			}
		}
	if ($a3tbl == $table) {
		$phpgw->db->query("SELECT * from ${pre}acc_trans WHERE attrib3='$id'");
		if ($phpgw->db->num_rows()>0) {
			$phpgw->db->next_record();
			$err = "$errmsg1 $journal id#".$phpgw->db->f('trans_id') ;
			}
		}
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Decode 'where' filter string

    function decode_where($filter) {
	global $ckapi,$phpgw ;

	if (trim($filter)<>"") {
		$markpri = "zzAnDzz" ;
		$marksec = "z2z1z3z" ;
		$pieces = explode($markpri,$filter) ;
		foreach ($pieces as $piece) {
			list($str1,$str2) = explode($marksec,$piece) ;
			$type = substr($str1,0,1) ;
			$str1 = substr($str1,1) ;
			if (strlen($str1)>15 or strlen($str2)>15) {
				echo "Please inform System Admin: Possible (type 1) injected SQL attack -$piece==<br>";
				exit() ;
				}	
			if (substr_count($piece," ")>0) {
				echo "Please inform System Admin: Possible (type 2) injected SQL attack -$piece==<br>";
				exit() ;
				}
			switch ($type) :
				case "0" :	$where .= "$str1 $str2" ;		break ;
				case "1" :	$where .= " AND $str1 = '$str2' " ;	break ;
				case "2" :	$where .= " AND $str1 >= '$str2' ";	break ;
				case "3" :	$where .= " AND $str1 > '$str2' ";	break ;
				case "4" :	$where .= " AND $str1 <= '$str2' ";	break ;
				case "5" :	$where .= " AND $str1 < '$str2' ";	break ;
				case "6" :	$where .= " AND lower($str1) like lower('%$str2%') ";  break;
				case "7" :	$where .= " AND OPEN " ;		break ;
				case "8" :	$where .= " AND $str1" ;		break ;
				case "9" :	$where .= " AND position($str1 in $str2)>0" ;		break ;
				endswitch ;
			}
		}
	return $where ;
	}

//---- Decode 'where' filter string

    function process_footer() {
	global $phpgw ;
	
	$phpgw->common->phpgw_footer();
	}
    }

?>
