<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: functions.inc.php,v 0.0.5 2002/02/11 C K Wu $ */



// This is loaded by default

    function init() {
	}

//---- Set Up Account Number Select Option List

    function account_selectlist($filter,$default) {
	global $phpgw,$pre ;

	$sql="SELECT id, accno,description FROM ${pre}chart $filter ORDER BY accno" ;
	$phpgw->db->query($sql);
	$selectlist="";
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$accno = $phpgw->db->f('accno');
		$description = substr($phpgw->db->f('description'),0,20);
		$selectlist .= "<OPTION value='$id'>$accno -- $description</OPTION>" ;
		}
	$selectlist = str_replace("'$default'","'$default'"." selected",$selectlist) ;
	return $selectlist ;
	}

//---- Set Up Status Select Option List

    function status_selectlist() {

	$optionc = lang('Cheque/Item cleared and appeared in bank statement') ;
	$options = lang('Cheque/Item stopped and bank informed') ;
	$selectlist = "<OPTION value='c'>c -- $optionc</OPTION>";
	$selectlist.= "<OPTION value='s'>s -- $options</OPTION>" ;
	$selectlist.= "<OPTION value=''></OPTION>" ;
	return $selectlist ;
	}

//---- Set Up Statement Item Source Select Option List

    function si_source_selectlist() {

	$optionsici = lang('Statement Item - Cash In') ;
	$optionsico = lang('Statement Item - Cash Out') ;
	$optionsibi = lang('Statement Item - Bank Interest') ;
	$optionsibc = lang('Statement Item - Bank Charge') ;
	$optionsiba = lang('Statement Item - Bank Adjustment') ;
	$selectlist = "<OPTION value='SICI'>$optionsici</OPTION>";
	$selectlist.= "<OPTION value='SICO'>$optionsico</OPTION>" ;
	$selectlist.= "<OPTION value='SIBI'>$optionsibi</OPTION>" ;
	$selectlist.= "<OPTION value='SIBC'>$optionsibc</OPTION>" ;
	$selectlist.= "<OPTION value='SIBA'>$optionsiba</OPTION>" ;
	return $selectlist ;
	}

//---- Set Up Suspense Item Source Select Option List

    function su_source_selectlist() {

	$selectlist = "<OPTION value='SUSP'>".lang('Suspense Item')."</OPTION>";
	return $selectlist ;
	}

//---- This function, input2date($idate), is made to check date-input from an HTML-form
 //--- and bring it to the YYYY-MM-DD format that it can be
 //--- insertet in a Date-Field of a MySQL-Table.
 //
 //--- Input-Formats can be:
 //--- "d.m.y" or "y.m.d" or "d.m" or "d"
 //--- if year or month and year are missing, these values are
 //--- taken from the current date.
 //
 //--- When the result-String is empty, the date-input was wrong.
 //
 //--- Usage: $date_ok = input2date($date_from_form_field);
 //

 function input2date($idate)
 {
   $token= "-./ ";

   $p1 = strtok($idate,$token);
   $p2 = strtok($token);
   $p3 = strtok($token);
   $p4 = strtok($token);

   $date= "";
   $y= ""; $m= ""; $d= "";

    // check 'd.m.y'
   if (($p1>0 && $p1<32) &&
       ($p2>0 && $p2<13) &&
       ($p3>32))
   {
     $y=$p3;
     $m=$p2;
     $d=$p1;
   }

    // check 'y.m.d'
   if ($y ==  "" &&
       ($p1>32) &&
       ($p2>0 && $p2<13) &&
       ($p3>0 && $p3<32))
   {
     $y=$p1;
     $m=$p2;
     $d=$p3;
   }

    // check 'd.m'
   if ($y ==  "" &&
       ($p3== "") &&
       ($p2>0 && $p2<13) &&
       ($p1>0 && $p1<32))
   {
     $y=date( "Y");
     $m=$p2;
     $d=$p1;
   }

    // check 'd'
   if ($y ==  "" &&
       ($p3== "") &&
       ($p2== "") &&
       ($p1>0 && $p1<32))
   {
     $y=date( "Y");
     $m=date( "m");
     $d=$p1;
   }

    // add 1900 or 2000 to year
   if ($y!= "" && $y<=99)
   {
     if ($y>=70) $y = $y + 1900;
     if ($y<70) $y = $y + 2000;
   }

   if ($y!= "")
   {
     if (checkdate($m, $d, $y))
       $date= "$y-$m-$d";
   }

   return $date;
 }
  

    init();

?>
