<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.leaveapp.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class leaveapp {

//---- Leave Application List SQL Formation

    function leaveapp_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$lang_leave = strtolower(lang('leave')) ;
	if (!$order)	$order = "staff,leavefrom,leaveto" ;
	if (!$sort)	$sort = "ASC" ;
	$sql =  "SELECT b.name as staff,a.*,description " ;
	$sql.=  "FROM ${pre}leaveapp a, ${pre}employee b, ${pre}hrcode c ";
	$sql.=  "WHERE 1=1 $where and empid=b.id and leavecode=c.name and lower(c.type)='$lang_leave' " ;
	$sql.=	"order by $order $sort" ;
	return $sql ;
	}

//---- Leave Application Read

    function leaveapp_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT * from $table WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	if ($ckapi[params_post][op]<>'view')	$dt[approved_by] = lang("HR staff") ;
	if (!is_array($uniqueflds) or $op<>'edit')    return $dt;
	  else  {foreach ($uniqueflds as $key => $val)	$dt["old$val"]=$dt["$val"];	return $dt ;}
	}

//---- Leave Application Detail Validation Checks

    function leaveapp_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error = lang("Error") ;
	$leavefrom = $dt[leavefrom] ;
	$leaveto = $dt[leaveto] ;
	if (input2date($leavefrom)=="")		$err=lang("Invalid From Date");
	if (input2date($leaveto)=="")		$err=lang("Invalid To Date");
	$from = strtotime($leavefrom) ;
	$to = strtotime($leaveto) ;
	if ($from<mktime(0,0,0))		$err=lang("Leave application cannot be retrospective") ;
	if ($leavefrom<>"" and $leaveto<>"" and $from>$to)	$err=lang("From Date later than To Date") ;
	$duration = $dt[duration] ;
	if (!is_numeric($duration) or $duration=='' or $duration==0)
						$err=lang("invalid Workdays figure") ;
	if ($duration*10%5 <>0)			$err=lang("Workdays must be whole day or half a day") ;
	if ($leavefrom<>"" and $leaveto<>"" and ($to-$from)<(($duration-1)*24*60*60))
						$err=lang("Work Days > Leave Period duration") ;
	if (substr($leavefrom,0,4)<>substr($leaveto,0,4))
						$err=lang("Leave From year must equal Leave To year") ;
	$dt[id] = ($dt[id]=="") ? 0 : $dt[id] ;
	$sql =	"SELECT * FROM ${pre}leaveapp WHERE ((leavefrom>='$leavefrom' and leavefrom<='$leaveto') " ;
	$sql.=	"or (leaveto>='$leavefrom' and leaveto<='$leaveto')) and empid=$dt[empid] and id<>'$dt[id]'" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()>0)		$err=lang("This application overlaps with existing leave applications");
	$sql =	"SELECT * FROM ${pre}leaveapp WHERE (('$leavefrom'>=leavefrom and '$leavefrom'<=leaveto) " ;
	$sql.=	"or ('$leaveto'>=leavefrom and '$leaveto'<=leaveto)) and empid=$dt[empid] and id<>'$dt[id]'" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()>0)		$err=lang("This application overlaps with existing leave applications") ;

	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Leave Application Add Initialisation

    function leaveapp_add_init() {
	global $ckapi ;

	$ckapi[params_post][dt][approved_by] = lang("HR staff") ;
	}

//---- Leave Application Post - PostCommit Routine

    function leaveapp_post_postcommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$op = $ckapi[params_post][op] ;

	$user = $ckapi[hostsys][username];
	$phpgw->db->query("SELECT name,id FROM ${pre}employee WHERE username='$user'");
	$phpgw->db->next_record();
	$hrstaffname = $phpgw->db->f('name');
	$hrstaffid = $phpgw->db->f('id');
	$sql = "SELECT prefix,suffix FROM ${pre}email WHERE empid='$hrstaffid' and emailcode='BUSI'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$hrstaffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername " ;
	$sql.= "FROM ${pre}employee a, ${pre}employee b " ;
	$sql.= "WHERE a.id='$dt[empid]' and a.supervisor=b.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffname = $phpgw->db->f('staffname');
	$superid = $phpgw->db->f('superid');
	$supername = $phpgw->db->f('supername');
	$sql = "SELECT prefix,suffix FROM ${pre}email " ;
	$sql.= "WHERE empid='$dt[empid]' and emailcode='BUSI'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$sql = "SELECT prefix,suffix FROM ${pre}email " ;
	$sql.= "WHERE empid='$superid' and emailcode='BUSI'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$superemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$recipient = "$staffname < $staffemail >" ;

	$subject = lang("%1's Leave Application [From:%2 To:%3] %4 by HR Staff", $staffname,$dt[leavefrom],$dt[leaveto],$ckapi[phrases][actioned]) ;
	$message = '' ;
	$headers = "From: $hrstaffname < $hrstaffemail > \n" ;
	$charset = lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $hrstaffname < $hrstaffemail >\n" ;
	$result= mail($recipient,$subject,$message,$headers) ;
	$successmsg = lang("Email advising action on %1's Leave Application [From:%2 To:%3] successfully queued for despatch to",$staffname,$dt[leavefrom],$dt[leaveto]) ;
	$failuremsg = lang("Email advising action on %1's Leave Application [From:%2 To:%3] fails to deliver.  Please manually inform",$staffname,$dt[leavefrom],$dt[leaveto]) ;
	$lang_staff = lang("Staff:") ;
	if ($result)	$msg = "$msg<br>$lang_staff $successmsg $staffname." ;
		else	$msg = "$msg<br>$lang_staff $failuremsg $staffname." ;
	$recipient = "$supername < $superemail >" ;
	$lang_super = lang("Supervisor:") ;
	$result= mail($recipient,$subject,$message,$headers) ;
	if ($result)	$msg = "$msg<br>$lang_super $successmsg $supername." ;
		else	$msg = "$msg<br>$lang_super $failuremsg $supername." ;
	$ckapi[phrases]["reminder"] = $msg ;
	}

//---- Write Leave Application Detail

    function leaveapp_write() {
	global $ckapi,$phpgw ;

	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_empid',lang('Employee Name/#'));
	$t->set_var('lang_id',lang('ID#'));
	$t->set_var('lang_leavefrom',lang('Leave From'));
	$t->set_var('lang_leaveto',lang('Leave To'));
	$t->set_var('lang_duration',lang('Duration in Workdays'));
	$t->set_var('lang_leavecode',lang('Leave Code -- Description'));
	$t->set_var('lang_approved_by',lang('Approved By'));
	$user = $ckapi[hostsys][username];
	$where = (!$uniwhere) ? " WHERE id='$dt[empid]' " : $uniwhere;
	$t->set_var('empid_selectlist',employee_selectlist($where,$dt[empid])) ;
	$t->set_var('staff',$dt[staff]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('leavefrom',$dt[leavefrom]);
	$t->set_var('leaveto',$dt[leaveto]);
	$t->set_var('duration',$dt[duration]);
	$lang_leave = strtolower(lang('leave')) ;
	$where = "WHERE lower(type)='$lang_leave' and name<>'SL' and name<>'UA'" ;
	$leavecode_sl = hrcodename_selectlist($where,$dt[leavecode],'long');
	$t->set_var('leavecode_selectlist',$leavecode_sl);
	$t->set_var('approved_by',$dt[approved_by]);
	$t->parse('out','report',True);
	}

    }

?>
