<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.bulkpayroll.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class bulkpayroll {

//---- Bulk Payrol List SQL Formation

    function bulkpayroll_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$sortkey = $ckapi[params][sortkey] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$lang_from = strtolower(lang('from')) ;
	$lang_to = strtolower(lang('to')) ;
	$frommarker = $lang_from.'::' ;  $frmarkerlen=strlen($frommarker);
	$tomarker = $lang_to.'::' ;  $tomarkerlen = strlen($tomarker) ;
	$frompos = "position('$frommarker' in description)+$frmarkerlen" ;
	$topos = "position('$tomarker' in description)+$tomarkerlen" ;
	$descdatefrom = "substring(description,$frompos,10)" ;
	$descdateto = "substring(description,$topos,10)" ;

	if (!$order)	$order = "datefrom,dateto" ;
	if (!$sort)	$sort = "ASC" ;
	$sql =	"SELECT $descdatefrom as datefrom,$descdateto as dateto,description,id " ;
	$sql.=	"FROM ${pre}gl WHERE source='PYRO' $where order by $order $sort" ;

	return $sql ;
	}

//---- Write payroll Header

    function bulkpayroll_header_write(&$t, &$dt) {
	global $phpgw ;

	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('lang_datefrom',lang('Payroll Period From'));
	$t->set_var('lang_dateto',lang('Payroll Period To'));
	$t->set_var('id',$dt[id]) ;
	$t->set_var('datefrom',$dt[datefrom]) ;
	$t->set_var('dateto',$dt[dateto]) ;

	$t->set_var('lang_autopay',lang('Autopay Information'));
	$t->set_var('lang_other',lang('Other Information'));
	$t->set_var('lang_bankac',lang('Bank Account#'));
	$t->set_var('lang_bankacname',lang('Bank Account Name'));
	$t->set_var('lang_net',lang('Net Pay (A+B-C)'));
	$t->set_var('lang_recur',lang('Recurring Item (A)'));
	$t->set_var('lang_nonrecur',lang('Non-recurring Item (B)'));
	$t->set_var('lang_reductn',lang('Summary Level Reduction (C)'));
	$t->set_var('lang_contri',lang('Company Contribution'));

	$t->set_var('lang_total',lang('Total'));

	$t->parse('out','report',True);

	}

//---- Write payroll Detail

    function bulkpayroll_detail_write(&$t, &$dt) {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;

	$sql = "SELECT mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor " ;
	$sql.= "FROM ${pre}defaults" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	switch ($dt[period]) :
		case "mn" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('mndfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('mnhfactor') ;	break ;
		case "sm" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('smdfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('smhfactor') ;	break ;
		case "wk" :	$dt[daypay] = $dt[salary]/$phpgw->db->f('wkdfactor') ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('wkhfactor') ;	break ;
		case "dy" :	$dt[daypay] = $dt[salary] ;
				$dt[hourpay] = $dt[salary]/$phpgw->db->f('dyhfactor') ;	break ;
		case "hr" :	$dt[daypay] = $dt[salary] * $phpgw->db->f('dyhfactor') ;
				$dt[hourpay] = $dt[salary] ;				break ;
		endswitch ;
	$dt[daypay] = sprintf("%01.2f",$dt[daypay]) ;
	$dt[hourpay] = sprintf("%01.2f",$dt[hourpay]) ;

	$id = $dt[id] ;
	$empid = $dt[empid] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

	$temp = $dt[temp] ;
	$temp1 = $dt[temp1] ;
	$phpgw->db->query($dt[creattempsql]);

	$t->set_var('bankac',$dt[bankac]) ;
	$t->set_var('bankacname',$dt[bankacname]) ;
	$tot_amount = 0 ;
	For ($i=1;isset($dt['eaid'.$i]);$i++) {
		$qty = 1 ;
		$eaid	=	$dt['eaid'.$i] ;
		$phpgw->db->query("SELECT * from ${pre}pyrcode where id='$eaid'");
		$phpgw->db->next_record();
		$basis		=	$phpgw->db->f('basis') ;
		$unit		=	$phpgw->db->f('unit') ;
		$unitamt	=	(substr_count($basis,'pc')>0) ? $phpgw->db->f('unitamt') : 1 ;
		$rate		=	$phpgw->db->f('rate') ;
		if (substr_count($basis,'qty')>0)	$qty = $dt['qty'.$i];
		if (substr_count($basis,'bs')>0)	$unitamt = $dt[salary] ;
		if (substr_count($basis,'hp')>0)	$unitamt = $dt[hourpay] ;
		if (substr_count($basis,'dp')>0)	$unitamt = $dt[daypay] ;
		$amount = sprintf("%01.2f",sprintf("%01.4f",$qty*$unitamt*$rate)) ;
		if (substr_count($basis,'amt')>0)	$amount=$dt['amount'.$i];
		$t->set_var('eaid_selectlist',eaid_selectlist("WHERE id=$eaid",'','short')) ;
		$t->set_var('basis',$basis) ;
		$t->set_var('qty',$qty) ;
		$t->set_var('unit',$unit) ;
		$t->set_var('unitamt',$unitamt) ;
		$t->set_var('rate',$rate) ;
		$t->set_var('amount',$amount) ;
		$dt['qty'.$j] = $qty ;
		$dt['amount'.$j] = $amount ;
		$t->set_var('comment',lang('recurring')) ;

		$chart_id = $dt['chart_id'.$i] ;
		$phpgw->db->query("INSERT INTO $temp(pyrcodeid,amount) VALUES('$eaid','$amount')");
		$dramt = -$amount ;
		$sql = "INSERT INTO $temp1(empid,type,codeid,basis,qty,unit,unitamt,rate,amount,chart_id) " ;
		$sql.= "VALUES ('$empid','PYRC','$eaid','$basis','$qty','$unit','$unitamt','$rate'," ;
		$sql.= "'$dramt','$chart_id')" ;
		$phpgw->db->query($sql) ;
		$tot_amount += $amount ;
		}
	$t->set_var('tot_amount',$tot_amount) ;

	$tot_nramount = 0 ;	$t->set_var('nrdetail_section','') ;
	For ($i=1;isset($dt['nreaid'.$i]);$i++) {
		$nrqty = 1 ;
		$nreaid	=	$dt['nreaid'.$i] ;
		$phpgw->db->query("SELECT * from ${pre}pyrcode where id='$nreaid'");
		$phpgw->db->next_record();
		$nrbasis	=	$phpgw->db->f('basis') ;
		$nrunit		=	$phpgw->db->f('unit') ;
		$nrunitamt	=	(substr_count($nrbasis,'pc')>0) ? $phpgw->db->f('unitamt') : 1 ;
		$nrrate		=	$phpgw->db->f('rate') ;
		if (substr_count($nrbasis,'qty')>0)	$nrqty = $dt['nrqty'.$i];
		if (substr_count($nrbasis,'bs')>0)	$nrunitamt = $dt[salary] ;
		if (substr_count($nrbasis,'hp')>0)	$nrunitamt = $dt[hourpay] ;
		if (substr_count($nrbasis,'dp')>0)	$nrunitamt = $dt[daypay] ;
		$nramount = sprintf("%01.2f",sprintf("%01.4f",$nrqty*$nrunitamt*$nrrate)) ;
		if (substr_count($nrbasis,'amt')>0)	$nramount=$dt['nramount'.$i];
		$nrcomment = $dt['nrcomment'.$i] ;
		$nrapproved_by = $dt['nrapproved_by'.$i] ;
		$t->set_var('nreaid_selectlist',eaid_selectlist("WHERE id=$nreaid",'','short')) ;
		$t->set_var('nrapproved_by',$nrapproved_by) ;
		$t->set_var('nrbasis',$nrbasis) ;
		$t->set_var('nrqty',$nrqty) ;
		$t->set_var('nrunit',$nrunit) ;
		$t->set_var('nrunitamt',$nrunitamt) ;
		$t->set_var('nrrate',$nrrate) ;
		$t->set_var('nramount',$nramount) ;
		$dt['nrqty'.$j] = $nrqty ;
		$dt['nramount'.$j] = $nramount ;
		$t->set_var('nrcomment',$nrcomment) ;

		$nrchart_id = $dt['nrchart_id'.$i] ;
		$phpgw->db->query("INSERT INTO $temp(pyrcodeid,amount) VALUES('$nreaid','$nramount')");
		$dramt = -$nramount ;
		$sql = "INSERT INTO $temp1(empid,type,codeid,basis,qty,unit,unitamt,rate," ;
		$sql.= "amount,comment,approved_by,chart_id) " ;
		$sql.= "VALUES ('$empid','PYNR','$nreaid','$nrbasis','$nrqty','$nrunit','$nrunitamt'," ;
		$sql.= "'$nrrate','$dramt','$nrcomment','$nrapproved_by','$nrchart_id')" ;
		$phpgw->db->query($sql) ;
		$tot_nramount += $nramount ;
		}
	$t->set_var('tot_nramount',$tot_nramount) ;

	$tot_rdamount = 0 ;	$t->set_var('rdtn_section','') ;
	For ($i=1;isset($dt['rdtnid'.$i]);$i++) {
		$rdtnid = $dt['rdtnid'.$i] ;
		$sql =	"SELECT sum(amount) as exemamt from $temp a,${pre}rdtnexem b " ;
		$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and rdtnid='$rdtnid' " ;
		$sql.=		"and amount>=min and amount<=max" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$exemamt = $phpgw->db->f('exemamt') ;
		$sql =	"SELECT sum(min) as exemmin from $temp a,${pre}rdtnexem b " ;
		$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and rdtnid='$rdtnid' " ;
		$sql.=		"and amount<min and actmin='lmt'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$exemmin = $phpgw->db->f('exemmin') ;
		$sql =	"SELECT sum(max) as exemmax from $temp a,${pre}rdtnexem b " ;
		$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and rdtnid='$rdtnid' " ;
		$sql.=		"and amount>max and actmax='lmt'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$exemmax = $phpgw->db->f('exemmax') ;
		$rdbaseamt = $tot_amount+$tot_nramount-$exemamt-$exemmin-$exemmax ;

		$sql =	"SELECT max(step) as rdstep FROM ${pre}rdtnrate a,${pre}reductn b " ;
		$sql.=	"WHERE ($rdbaseamt-floor)>=step and rdtnid='$rdtnid' and b.id='$rdtnid'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$rdstep = $phpgw->db->f('rdstep') ;
		$sql =	"SELECT floor,rate,subtract,min,actmin,max,actmax " ;
		$sql.=	"FROM ${pre}rdtnrate a,${pre}reductn b " ;
		$sql.=	"WHERE step='$rdstep' and rdtnid='$rdtnid' and b.id='$rdtnid'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$rdfloor = $phpgw->db->f('floor') ;
		$rdrate = $phpgw->db->f('rate') ;
		$rdsubtract = $phpgw->db->f('subtract') ;
		$rdmin = $phpgw->db->f('min') ;
		$rdactmin = $phpgw->db->f('actmin') ;
		$rdmax = $phpgw->db->f('max') ;
		$rdactmax = $phpgw->db->f('actmax') ;
		$rdamount = sprintf("%01.2f",($rdbaseamt-$rdfloor) * $rdrate - $rdsubtract) ;
		$rdremark = "" ;
		if ($rdamount<$rdmin) {
			$rdamount = ($rdactmin=="lmt") ? $rdmin : 0 ;
			$rdremark = ($rdactmin=="lmt") ? lang('Set to Min') : lang('Min Reject') ;
			}
		if ($rdamount>$rdmax) {
			$rdamount = ($rdactmax=="lmt") ? $rdmax : 0 ;
			$rdremark = ($rdactmax=="lmt") ? lang('Set to Max') : lang('Max Reject') ;
			}
		$t->set_var('rdtnid_selectlist',rdtnid_selectlist("WHERE id=$rdtnid",'','short')) ;
		$t->set_var('rdbaseamt',$rdbaseamt) ;
		$t->set_var('rdfloor',$rdfloor) ;
		$t->set_var('rdrate',$rdrate) ;
		$t->set_var('rdsubtract',$rdsubtract) ;
		$t->set_var('rdamount',$rdamount) ;
		$t->set_var('rdremark',$rdremark) ;
		$tot_rdamount += $rdamount ;
		$rdchart_id = $dt['rdchart_id'.$i] ;
		$cramt = $rdamount ;
		$sql = "INSERT INTO $temp1(empid,type,codeid,base,floor,rate," ;
		$sql.= "subtract,amount,comment,chart_id) " ;
		$sql.= "VALUES ('$empid','RDTN','$rdtnid','$rdbaseamt','$rdfloor','$rdrate'," ;
		$sql.= "'$rdsubtract','$cramt','$rdremark','$rdchart_id')" ;
		$phpgw->db->query($sql) ;
		}
	$t->set_var('tot_rdamount',$tot_rdamount) ;
	$cramt = $net = $tot_amount+$tot_nramount-$tot_rdamount ;
	$t->set_var('net',$net) ;
	$sql = "INSERT INTO $temp1(empid,type,amount,chart_id) " ;
	$sql.= "VALUES ('$empid','NETP','$cramt','$dt[chart_id]')" ;
	$phpgw->db->query($sql) ;

	$tot_ctamount = 0 ;	$t->set_var('cntr_section','') ;
	For ($i=1;isset($dt['cntrid'.$i]);$i++) {
		$cntrid = $dt['cntrid'.$i] ;
		$sql =	"SELECT sum(amount) as exemamt from $temp a,${pre}cntrexem b " ;
		$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and cntrid='$cntrid' " ;
		$sql.=		"and amount>=min and amount<=max" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$exemamt = $phpgw->db->f('exemamt') ;
		$sql =	"SELECT sum(min) as exemmin from $temp a,${pre}cntrexem b " ;
		$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and cntrid='$cntrid' " ;
		$sql.=		"and amount<min and actmin='lmt'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$exemmin = $phpgw->db->f('exemmin') ;
		$sql =	"SELECT sum(max) as exemmax from $temp a,${pre}cntrexem b " ;
		$sql.=	"WHERE a.pyrcodeid=b.pyrcodeid and cntrid='$cntrid' " ;
		$sql.=		"and amount>max and actmax='lmt'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$exemmax = $phpgw->db->f('exemmax') ;
		$ctbaseamt = $tot_amount+$tot_nramount-$exemamt-$exemmin-$exemmax ;

		$sql =	"SELECT max(step) as ctstep from ${pre}cntrrate a,${pre}contri b " ;
		$sql.=	"WHERE ($ctbaseamt-floor)>=step and cntrid='$cntrid' and b.id='$cntrid'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$ctstep = $phpgw->db->f('ctstep') ;
		$sql =	"SELECT floor,rate,subtract,min,actmin,max,actmax " ;
		$sql.=	"FROM ${pre}cntrrate a,${pre}contri b " ;
		$sql.=	"WHERE step='$ctstep' and cntrid='$cntrid' and b.id='$cntrid'" ;
		$phpgw->db->query($sql);
		$phpgw->db->next_record();
		$ctfloor = $phpgw->db->f('floor') ;
		$ctrate = $phpgw->db->f('rate') ;
		$ctsubtract = $phpgw->db->f('subtract') ;
		$ctmin = $phpgw->db->f('min') ;
		$ctactmin = $phpgw->db->f('actmin') ;
		$ctmax = $phpgw->db->f('max') ;
		$ctactmax = $phpgw->db->f('actmax') ;
		$ctamount = sprintf("%01.2f",($ctbaseamt-$ctfloor) * $ctrate - $ctsubtract) ;
		$ctremark = "" ;
		if ($ctamount<$ctmin) {
			$ctamount = ($ctactmin=="lmt") ? $ctmin : 0 ;
			$ctremark = ($ctactmin=="lmt") ? lang('Set to Min') : lang('Reject') ;
			}
		if ($ctamount>$ctmax) {
			$ctamount = ($ctactmax=="lmt") ? $ctmax : 0 ;
			$ctremark = ($ctactmax=="lmt") ? lang('Set to Max') : lang('Max Reject') ;
			}
		$t->set_var('cntrid_selectlist',cntrid_selectlist("WHERE id=$cntrid",'','short')) ;
		$t->set_var('ctbaseamt',$ctbaseamt) ;
		$t->set_var('ctfloor',$ctfloor) ;
		$t->set_var('ctrate',$ctrate) ;
		$t->set_var('ctsubtract',$ctsubtract) ;
		$t->set_var('ctamount',$ctamount) ;
		$t->set_var('ctremark',$ctremark) ;
		$tot_ctamount += $ctamount ;
		$ac_exp = $dt['ac_exp'.$i] ;
		$ac_liab = $dt['ac_liab'.$i] ;
		$dramt = -$ctamount ;
		$cramt = $ctamount ;
		$sql = "INSERT INTO $temp1(empid,type,codeid,base,floor,rate," ;
		$sql.= "subtract,amount,comment,chart_id) " ;
		$sql.= "VALUES ('$empid','CTDR','$cntrid','$ctbaseamt','$ctfloor','$ctrate'," ;
		$sql.= "'$ctsubtract','$dramt','$ctremark','$ac_exp')" ;
		$phpgw->db->query($sql) ;
		$sql = "INSERT INTO $temp1(empid,type,codeid,base,floor,rate," ;
		$sql.= "subtract,amount,comment,chart_id) " ;
		$sql.= "VALUES ('$empid','CTCR','$cntrid','$ctbaseamt','$ctfloor','$ctrate'," ;
		$sql.= "'$ctsubtract','$cramt','$ctremark','$ac_liab')" ;
		$phpgw->db->query($sql) ;
		}
	$t->set_var('tot_ctamount',$tot_ctamount) ;

	$net = $tot_amount+$tot_nramount-$tot_rdamount ;
	$t->set_var('name',$dt[name]) ;
	$t->set_var('recur',$tot_amount) ;
	$t->set_var('nonrecur',$tot_nramount) ;
	$t->set_var('reductn',$tot_rdamount) ;
	$t->set_var('net',$net) ;
	$t->set_var('contri',$tot_ctamount) ;
	$dt[recur] = $tot_amount ;
	$dt[nonrecur] = $tot_nramount ;
	$dt[reductn] = $tot_rdamount ;
	$dt[net] = $net ;
	$dt[contri] = $tot_ctamount ;

	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	$phpgw->db->query("DROP TABLE $temp");

	}

//---- Write Journal Header

    function journal_header_write(&$t, $jl) {
	global $phpgw ;

	$t->set_var('lang_date',lang('Date :'));
	$t->set_var('lang_source',lang('Source :'));
	$t->set_var('lang_description',lang('Description :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('lang_attrib1',$a1cap);
	$t->set_var('lang_attrib2',$a2cap);
	$t->set_var('lang_attrib3',$a3cap);
	$t->set_var('transdate',$jl[transdate]) ;
	$t->set_var('source',$jl[source]) ;
	$t->set_var('description',$jl[description]) ;
	$t->set_var('id',$jl[id]) ;

	$t->set_var('lang_replicate',lang('Replicate Attribute Values from Caption :'));
	$t->set_var('lang_nonbs',lang('Done'));
	$t->set_var('lang_all',lang('Done'));
	$t->set_var('lang_update',lang('Done'));
	$t->set_var('lang_newrow',lang('Done'));

	$t->parse('out','screen',True);
	}

//---- Write Journal Detail

    function journal_detail_write(&$t, $jl, $posted) {
	global $ckapi,$phpgw ;

	$row_ = lang("Row")." " ;

	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_accno',lang('Account Number'));
	$t->set_var('lang_attrib1',lang("Attribute").":<br>$a1cap");
	$t->set_var('lang_attrib2',lang("Attribute"),":<br>$a2cap");
	$t->set_var('lang_attrib3',lang("Attribute").":<br>$a3cap");
	$at1cap = $jl[attrib1_cap] ;
	$at2cap = $jl[attrib2_cap] ;
	$at3cap = $jl[attrib3_cap] ;
	$t->set_var('attrib1cap_selectlist',str_replace("'$at1cap'","'$at1cap'"." selected",$a1slist)) ;
	$t->set_var('attrib2cap_selectlist',str_replace("'$at2cap'","'$at2cap'"." selected",$a2slist)) ;
	$t->set_var('attrib3cap_selectlist',str_replace("'$at3cap'","'$at3cap'"." selected",$a3slist)) ;
	$t->set_var('lang_dr',lang('Debit'));
	$t->set_var('lang_cr',lang('Credit'));
	$t->set_var('lang_delete',lang('Delete'));
	$total_dr = 0;
	$total_cr = 0;
	$acc_list = account_selectlist("WHERE charttype='A'",'') ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($jl['accno'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('accno_fld','accno'.$i) ;
			$t->set_var('attrib1_fld','attrib1'.$i) ;
			$t->set_var('attrib2_fld','attrib2'.$i) ;
			$t->set_var('attrib3_fld','attrib3'.$i) ;
			$t->set_var('dr_fld','dr'.$i);
			$t->set_var('cr_fld','cr'.$i);
			$t->set_var('account_selectlist',$acc_list);
			$t->set_var('attrib1_selectlist',$a1slist) ;
			$t->set_var('attrib2_selectlist',$a2slist) ;
			$t->set_var('attrib3_selectlist',$a3slist) ;
			$t->set_var('dr',"") ;
			$t->set_var('cr',"") ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('journal_section','journal', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;
		$chart_id	=	$jl['accno'.$i] ;
		$attrib1	=	$jl['attrib1'.$i] ;
		$attrib2	=	$jl['attrib2'.$i] ;
		$attrib3	=	$jl['attrib3'.$i] ;
		$dr		=	$jl['dr'.$i];
		$cr		=	$jl['cr'.$i];
		$total_dr	+=	$dr ;
		$total_cr	+=	$cr ;
		$accno_fld	=	'accno'.$j ;
		$attrib1_fld	=	'attrib1'.$j ;
		$attrib2_fld	=	'attrib2'.$j ;
		$attrib3_fld	=	'attrib3'.$j ;
		$dr_fld		=	'dr'.$j ;
		$cr_fld		=	'cr'.$j ;
		$t->set_var('accno_fld',$accno_fld) ;
		$t->set_var('attrib1_fld',$attrib1_fld) ;
		$t->set_var('attrib2_fld',$attrib2_fld) ;
		$t->set_var('attrib3_fld',$attrib3_fld) ;
		$t->set_var('dr_fld',$dr_fld);
		$t->set_var('cr_fld',$cr_fld);
		$t->set_var('account_selectlist',str_replace("'$chart_id'","'$chart_id' selected",$acc_list)) ;
		$t->set_var('attrib1_selectlist',str_replace("'$attrib1'","'$attrib1'"." selected",$a1slist)) ;
		$t->set_var('attrib2_selectlist',str_replace("'$attrib2'","'$attrib2'"." selected",$a2slist)) ;
		$t->set_var('attrib3_selectlist',str_replace("'$attrib3'","'$attrib3'"." selected",$a3slist)) ;
		$t->set_var('dr',$dr) ;
		$t->set_var('cr',$cr) ;
		if ($posted)	$t->set_var('insrowno',lang("Done")); else $t->set_var('insrowno',$row_.$j);
		if ($posted)	$t->set_var('delrowno',lang("Done")); else $t->set_var('delrowno',$row_.$j);
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('journal_section','journal', True);
		}
	if ($i==2 and $delrowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('accno_fld','accno'.$i) ;
		$t->set_var('attrib1_fld','attrib1'.$i) ;
		$t->set_var('attrib2_fld','attrib2'.$i) ;
		$t->set_var('attrib3_fld','attrib3'.$i) ;
		$t->set_var('dr_fld','dr'.$i);
		$t->set_var('cr_fld','cr'.$i);
		$t->set_var('account_selectlist',$acc_list);
		$t->set_var('attrib1_selectlist',$a1slist) ;
		$t->set_var('attrib2_selectlist',$a2slist) ;
		$t->set_var('attrib3_selectlist',$a3slist) ;
		$t->set_var('dr',"") ;
		$t->set_var('cr',"") ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('journal_section','journal', True);
		}
	$t->set_var('lang_total',lang('Total'));
	$t->set_var('total_dr',sprintf("%01.2f",$total_dr)) ;
	$t->set_var('total_cr',sprintf("%01.2f",$total_cr)) ;

	$t->parse('out','screen',True);
	}

//---- Bulk Payroll Post - PreCommit Routine

    function bulkpayroll_post_precommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	For ($i=1;isset($dt['accno'.$i]);$i++) {
		$chart_id	= 	$dt['accno'.$i];
		$attrib1	=	$dt['attrib1'.$i] ;
		$attrib2	=	$dt['attrib2'.$i] ;
		$attrib3	=	$dt['attrib3'.$i] ;
		$dr		=	$dt['dr'.$i] ;
		$cr		=	$dt['cr'.$i] ;
		if ($dr==0) $amount=$cr; else $amount=-$dr;
		$attrib1 = ($attrib1=="") ? 0 : $attrib1 ;
		$attrib2 = ($attrib2=="") ? 0 : $attrib2 ;
		$attrib3 = ($attrib3=="") ? 0 : $attrib3 ;
		$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,attrib1,attrib2,attrib3," ;
		$sql.= "amount,transdate) " ;
		$sql.= "VALUES ('$id','$chart_id','$attrib1','$attrib2','$attrib3'," ;
		$sql.= "'$amount','$dt[transdate]')";
		$phpgw->db->query($sql);
		}
	if ($temp1<>"") {
		$phpgw->db->query("UPDATE $temp1 SET trans_id='$id'");
		$phpgw->db->query("INSERT INTO ${pre}pyrohist SELECT * FROM $temp1");
		}
	}

    }

?>
