<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.qcash.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class qcash {

//---- Qcash Detail Validation Checks

    function qcash_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$table = $ckapi[params][table] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	if (!$dt[name] or $dt[name]=="")		$err=lang('Quasi-Cash Name missing');
		else	{
			$phpgw->db->query("SELECT * from $table WHERE name='$dt[name]'") ;
			if ($phpgw->db->num_rows()<>0 and $dt[name]<>$dt[oldname])
				$err=lang('Quasi-Cash name already in use');
			}
	if ($dt[minsale]>$dt[maxsale])			$err=lang('Min sale must be <= Max sale');
	if ($dt[minqty]>$dt[maxqty])			$err=lang('Min qty must be <= Max qty');
	if ($dt[minvalue]>$dt[maxvalue])		$err=lang('Min value must be <= Max value');
	if ($dt[value] and !is_numeric($dt[value]))	$err=lang("Face value must be numeric");
	if ($dt[minsale] and !is_numeric($dt[minsale]))	$err=lang("Min cash sale must be numeric");
	if ($dt[maxsale] and !is_numeric($dt[maxsale]))	$err=lang("Max cash sale must be numeric");
	if ($dt[minqty] and !is_numeric($dt[minqty]))	$err=lang("Min qty must be numeric");
	if ($dt[maxqty] and !is_numeric($dt[maxqty]))	$err=lang("Max qty must be numeric");
	if ($dt[minvalue] and !is_numeric($dt[minvalue]))	$err=lang("Min value must be numeric");
	if ($dt[maxvalue] and !is_numeric($dt[maxvalue]))	$err=lang("Max value must be numeric");
	if (input2date($dt[start])=="")			$err=lang('Invalid [Valid from] Date');
	if (input2date($dt[endd])=="")			$err=lang('Invalid [Valid to] Date');
	if (strtotime($dt[start])>strtotime($dt[endd]))	$err=lang('[Valid from] LaterThan [Valid to]');
	if (strtotime($dt[start])=="-1") 		$err=lang("[Valid from] beyond valid date range");
	if (strtotime($dt[endd])=="-1")			$err=lang("[Valid to] beyond valid date range");
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Qcash Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$cashsale = lang('cash sale') ;
	$errmsg1 = lang("This quasi-cash is in use within an existing") ;
	$id = $dt[id] ;
	$phpgw->db->query("SELECT * from ${pre}positem WHERE itemid='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $cashsale id#".$phpgw->db->f('id') ;
		}
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Qcash Detail

    function qcash_write() {
	global $ckapi,$phpgw ;

	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_splan_id',lang('Sales Promotion Plan ID:')."  ");
	$t->set_var('lang_name',lang('Name'));
	$t->set_var('lang_value',lang('Nominal Face Value'));
	$t->set_var('lang_minsale',lang('Min Cash Sale'));
	$t->set_var('lang_maxsale',lang('Max Cash Sale'));
	$t->set_var('lang_minqty',lang('Min Qty per Tran'));
	$t->set_var('lang_maxqty',lang('Max Qty per Tran'));
	$t->set_var('lang_minvalue',lang('Min ($)value per Tran'));
	$t->set_var('lang_maxvalue',lang('Max ($)value per Tran'));
	$t->set_var('lang_start',lang('Valid from:'));
	$t->set_var('lang_endd',lang('Valid to:'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_linkageaccount',lang("Link to Ledger Accounts"));
	$t->set_var('lang_pos_accno',lang("POS - Quasi Cash"));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('splan_id',0);
//	$t->set_var('splan_id',$dt[splan_id]);
	$t->set_var('name',$dt[name]);
	$t->set_var('value',$dt[value]);
	$t->set_var('minsale',$dt[minsale]);
	$t->set_var('maxsale',$dt[maxsale]);
	$t->set_var('minqty',$dt[minqty]);
	$t->set_var('maxqty',$dt[maxqty]);
	$t->set_var('minvalue',$dt[minvalue]);
	$t->set_var('maxvalue',$dt[maxvalue]);
	$t->set_var('start',$dt[start]);
	$t->set_var('endd',$dt[endd]);
	$t->set_var('notes',$dt[notes]);
	$pos_accno = $dt[posacc_id] ;
	$t->set_var('pos_accno',$pos_accno);
	$posacsl = account_selectlist("WHERE link like '%CS:%' or link like '%CS'",$pos_accno);
	$t->set_var('pos_acc_option_block', "<OPTION value='0'>".lang('N/A')."</OPTION>".$posacsl);
	$t->parse('out','report',True);
	}

    }

?>
