<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.la.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class la {

//---- LA List SQL Formation

    function la_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$where = str_replace("approved_by=''","(approved_by='' or approved_by is NULL)",$where) ;
	$lang_leave = lang('leave') ;
	if (!$order) {$order = "staff,leavefrom,leaveto" ; }
	if (!$sort)  {$sort = "ASC" ; }
	$sql =  "SELECT b.name as staff,a.*,description " ;
	$sql.=  "FROM ${pre}leaveapp a, ${pre}employee b, ${pre}hrcode c " ;
	$sql.=  "WHERE $where and empid=b.id and leavecode=c.name and c.type='$lang_leave' " ;
	$sql.=	"order by $order $sort" ;
	return $sql ;
	}

//---- LA List Link Adjustement

    function la_list_adjust() {
	global $ckapi ;

	$t = &$ckapi[objects][template] ;
	if ($ckapi[params_list][dt][approved_by]=='')
		$t->set_var(array(	'lang_cancel'	=> '',
					'cancel'	=> ''	)) ;
	  else	$t->set_var(array(	'lang_approve'	=> '',
					'lang_reject'	=> '',
					'approve'	=> '',
					'reject'	=> ''	)) ;
	}

//---- LA Read

    function la_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("select * from ${pre}leaveapp WHERE id='$id'");
	$phpgw->db->next_record();
	return $phpgw->db->Record ;
	}

//---- LA Add Initialisation

    function la_add_init() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$user = $ckapi[hostsys][username];
	$phpgw->db->query("SELECT id FROM ${pre}employee WHERE username='$user'");
	$phpgw->db->next_record();
	$ckapi[params_post][dt][empid] = $phpgw->db->f('id');
	}


//---- LA Validation Checks

    function la_validate() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$err="";
	$error = lang("Error") ;
	if ($dt[reason]=="")	$err=lang("Cancel/Reject Reason Missing") ;

	if ($err)		$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write LA Detail

    function la_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_empid',lang('Employee Name/#'));
	$t->set_var('lang_id',lang('ID#'));
	$t->set_var('lang_leavefrom',lang('Leave From'));
	$t->set_var('lang_leaveto',lang('Leave To'));
	$t->set_var('lang_duration',lang('Duration in Workdays'));
	$t->set_var('lang_leavecode',lang('Leave Code -- Description'));
	$t->set_var('lang_approved_by',lang('Approved By'));
	$lang_leave = lang('leave') ;
	$user = $ckapi[hostsys][username];
	$empid = $dt[empid] ;
	$sql = "SELECT b.username FROM ${pre}employee a, ${pre}employee b " ;
	$sql.= "WHERE a.id='$empid' and a.supervisor=b.id";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	if ($user<>$phpgw->db->f('username')) {
		echo lang("You are not authorised to access the requested information.") ;
		exit() ;
		}
	$where = " WHERE id='$dt[empid]' " ;
	$t->set_var('empid_selectlist',employee_selectlist($where,$dt[empid])) ;
	$t->set_var('staff',$dt[staff]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('leavefrom',$dt[leavefrom]);
	$t->set_var('leaveto',$dt[leaveto]);
	$t->set_var('duration',$dt[duration]);
	$where = "WHERE type='$lang_leave' and name<>'SL' and name<>'UA'" ;
	$leavecode_sl = hrcodename_selectlist($where,$dt[leavecode],'long');
	$t->set_var('leavecode_selectlist',$leavecode_sl);
	$t->set_var('approved_by',$dt[approved_by]);
	$t->set_var('reason',$dt[reason]);
	$t->parse('out','report',True);
	}

//---- LA Post Initialisation

    function la_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][approved_by] = "" ;
	}

//---- LA Post - PostCommit Routine

    function la_post_postcommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$lang_tran = $ckapi[phrases][lang_tran] ;
	$actioned = $ckapi[phrases][actioned] ;

	$lang_from = lang("FROM") ;
	$lang_to = lang("TO") ;
	$lang_approval = lang("Approval") ;
	$lang_reason = lang("Reason") ;
	$inform = lang("Please manually inform") ;
	$leavefrom = $dt[leavefrom] ;
	$leaveto = $dt[leaveto] ;

	$sql = "SELECT a.name as staffname,a.supervisor as superid,b.name as supername ";
	$sql.= "FROM ${pre}employee a, ${pre}employee b WHERE a.id='$dt[empid]' and a.supervisor=b.id" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffname = $phpgw->db->f('staffname');
	$superid = $phpgw->db->f('superid');
	$supername = $phpgw->db->f('supername');
	$sql = "SELECT prefix,suffix FROM ${pre}email WHERE empid='$dt[empid]' and emailcode='BUSI'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$staffemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$sql = "SELECT prefix,suffix FROM ${pre}email WHERE empid='$superid' and emailcode='BUSI'";
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$superemail = $phpgw->db->f('prefix')."@".$phpgw->db->f('suffix') ;
	$recipient = "$staffname < $staffemail >" ;
	$message = '' ;
	$headers = "From: $supername < $superemail >\n" ;
	$charset = lang('charset') ;
	$headers.= "Content-Type: text/html; charset=$charset \n" ;
	$headers.= "Return-Path: $supername < $superemail >\n" ;

	switch ($op) :
	    case "approve" :
		$subject = "[$staffname] $lang_tran [$lang_from:$leavefrom $lang_to:$leaveto] $actioned." ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = lang("Email approving leave application successfully queued for despatch to") ;
		$failuremsg = lang("Email approving leave application fails to deliver.")."  $inform" ;
		break ;
	    case "cancel" :
		$subject = "[$staffname] $lang_tran [$lang_from:$leavefrom $lang_to:$leaveto] " ;
		$subject.= "$lang_approval $actioned.  $lang_reason: $dt[reason]" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg =lang("Email advising approval cancellation successfully queued for despatch to");
		$failuremsg =lang("Email advising approval cancellation fails to deliver.")."  $inform" ;
		break ;
	    case "reject" :
		$subject = "[$staffname] $lang_tran [$lang_from:$leavefrom $lang_to:$leaveto] $actioned.  " ;
		$subject.= "$lang_reason: $dt[reason]" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = lang("Email rejecting leave application successfully queued for despatch to") ;
		$failuremsg = lang("Email rejecting leave application fails to deliver.")."  $inform" ;
		break ;
	    endswitch ;

	if ($result)	$msg = "<br>$successmsg $staffname." ;
		else	$msg = "<br>$failuremsg $staffname." ;
	$ckapi[phrases]["reminder"] = $msg ;
	}

    }

?>

